classdef bdatacol
  
  properties %(SetAccess = public)
    name='';
    values={};
    sformat='';
    strlen=0;
    fun=[]; % function used to compute values
    numpy=''; % numpy format 
    info={};
  end
  
  methods
  
    function self = bdatacol(varargin) %name,value,sformat,strlen)
      p = inputParser;
      p.addParamValue('name','',@ischar);
      p.addParamValue('values',{},@iscell);
      p.addParamValue('sformat','',@ischar);
      p.addParamValue('strlen',0,@isscalar);
      p.addParamValue('info',{},@iscell);
      p.addParamValue('fun',[],@(x) isempty(x) || fc_tools.utils.isfunhandle(x));
      p.parse(varargin{:});
      R=p.Results;
      self.name=R.name; 
      self.values=R.values;
        
      self.sformat=R.sformat;
      self.strlen=R.strlen;
      self.fun=R.fun;
      self.info=R.info;
      if length(R.sformat)>1
        switch lower(R.sformat(end))
          case 'd'
            self.numpy='i4';
          case 's'
            self.numpy='s';
          case {'e','f'}
            self.numpy='f4';
          otherwise
            error('Unknown format %s',sformat)
        end
      else
        self.numpy='';
      end
    end
    
%      function self = bdatacol_bdata(bD,nIn)
%        assert(strcmp(class(bd),'fc_bench.bdata'))
%        self.name=bD.name;
%        self.sformat=bD.sformat;
%        self.strlen=bD.strlen;
%        if fc_tools.utils.isfunhandle(bD.value), self.fun=bD.value;end
%        self.info=bD.info;
%        self.numpy=bD.numpy;
%        self.values=cell(1,nIn);
%      end
    
  end % methods 
end % classdef    
    
